import React__default,{useState,useEffect}from'react';import {useStopwatch}from'react-timer-hook';import {useSelector}from'react-redux';import {currentTimerSelector,calculateTimeDurationSec}from'@admin-layout/timetracker-core';import moment from'moment';// Timer
const TimerComponent = () => {
    const currentTimer = useSelector(currentTimerSelector);
    const [startTimer, setStartTimer] = useState(false);
    const { start, reset, pause, hours, minutes, seconds } = useStopwatch({ autoStart: false, offsetTimestamp: 0 });
    useEffect(() => {
        if (currentTimer.startTime) {
            setStartTimer(true);
        }
    }, [currentTimer.startTime]);
    useEffect(() => {
        if (currentTimer && currentTimer.isPause && currentTimer.endTime === null) {
            if (startTimer) {
                pause();
            }
        }
        else if (currentTimer && (currentTimer.startTime === null || currentTimer.endTime !== null)) {
            if (startTimer) {
                reset(0, false);
                setStartTimer(false);
            }
        }
        else {
            if (startTimer) {
                start();
            }
            else {
                const passDur = calculateTimeDurationSec(currentTimer.startTime, moment().format(), currentTimer.pauseStatus);
                const currentDate = new Date();
                const stopwatchOffset = currentDate.setSeconds(currentDate.getSeconds() + passDur);
                reset(stopwatchOffset);
                setStartTimer(true);
            }
        }
    }, [currentTimer.startTime, currentTimer.endTime, currentTimer.isPause]);
    useEffect(() => {
        if (startTimer && currentTimer.isPause) {
            const passDur = calculateTimeDurationSec(currentTimer.startTime, moment().format(), currentTimer.pauseStatus);
            const currentDate = new Date();
            const stopwatchOffset = currentDate.setSeconds(currentDate.getSeconds() + passDur);
            reset(stopwatchOffset, false);
        }
    }, [startTimer]);
    return React__default.createElement(React__default.Fragment, null,
        hours < 10 ? `0${hours}` : hours,
        ":",
        minutes < 10 ? `0${minutes}` : minutes,
        ":",
        seconds < 10 ? `0${seconds}` : seconds);
};export{TimerComponent};//# sourceMappingURL=TimerComponent.js.map
